SystemOrganization addCategory: #SourceCity!

NBExternalStructure variableByteSubclass: #GLCityStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLCityStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:38'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;
         float a;
        )! !

!GLCityStructure methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:30'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;  
	   float a.
       
        )! !

NBExternalStructure variableByteSubclass: #GLFloatRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

NBExternalStructure variableByteSubclass: #GLFloatShinines
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatShinines class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat  r;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:14'!
fieldsDesc
  ^ #( 
         NBGLFloat x;
         NBGLFloat y;
         NBGLFloat z;  
        )! !

TestCase subclass: #BuildingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:24'!
testColorMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) colorSelector =0.
	self assert: ((c city districts at:1) buildings at:2) colorSelector =0.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:23'!
testHeightMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. 

	(c city districts) do:[
		:eachDistrict|
		eachDistrict buildings do:[
			:eachBuilding|
			Transcript cr;show: eachBuilding.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) heightSelector =  ((c city districts at:1) buildings at:1) model selectors size.
	self assert: ((c city districts at:1) buildings at:2) heightSelector =  ((c city districts at:1) buildings at:2) model selectors size.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:25'!
testWidthMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict. 
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) widthSelector = #1"((c city districts at:1) buildings at:1) model allSubclasses size".
	self assert: ((c city districts at:1) buildings at:2) widthSelector =  #1"((c city districts at:1) buildings at:2) model allSubclasses size".! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 16:58'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:08'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	"This method test, is just for show us what does normal import realize. How many build, districts ... and max metrics we can find"
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:01'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size = cimport numberOfBuilding.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' 'SourceCity' 'AST-Core').
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity').
	! !

TestCase subclass: #DistrictTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!DistrictTest methodsFor: 'tests' stamp: 'douaille 4/10/2012 15:01'!
testMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. ! !

!Float methodsFor: '*SourceCity' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !

GLViewportMorph subclass: #GLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLCity commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 15:34'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: configuration cameraXPos x: 1 y: 0  z: 0. 
	display gl rotatef_angle: configuration cameraYPos x: 0 y: 1  z: 0. 
	display gl rotatef_angle: configuration cameraZPos x: 0 y: 1  z: 0. 
! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 12:53'!
building: anArray
	|gl x z y |
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: face. 	
	gl begin: GL_QUADS.
	
		"front"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #((x asInteger) 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 (x asInteger)).
		
		"back"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #((x asInteger) 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(0 (x asInteger)).
	
		"left maybe reverse with right"
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #((x asInteger) 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(0 (x asInteger)).
	
		"right maybe reverse with left"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #((x asInteger) 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 (x asInteger)).
		
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: down.
	gl begin: GL_QUADS.
		"down"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #((x asInteger) 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 (x asInteger)).
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: top. 		
	gl begin: GL_QUADS.	
		"top"
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #((x asInteger) 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #((x asInteger) (x asInteger)).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(0 (x asInteger)).
	gl end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/25/2012 15:51'!
buildingColor: anArray color: aColor
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl enable: GL_NORMALIZE .
	gl begin: GL_QUADS;
		"front"
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x: (anArray first)+1 y: 0.1 z: anArray third;
		
		"back"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
	
		"left maybe reverse with right"
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		normal3d_nx: 1 ny: 1 nz: 1; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
	
		"right maybe reverse with left"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		
		"down"
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		
		"top"
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third ;
	end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 19:35'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = '<' )
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:05'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 17:25'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/25/2012 12:49'!
cityColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	
	gl := display gl.	
	gl begin: GL_QUADS;
		
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;

	end.
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/16/2012 10:19'!
cubicMatrix
	^ThreeDimensionalMatrix new
	 add: {-1. -1. 1};
	 add: {1. -1. 1};
	 add: {1. 1. 1};
	 add: {-1. 1. 1};
	
	 add: {-1. -1. -1};
	 add: {-1. 1. -1};
	 add: {1. 1. -1};
	 add: {1.-1. -1};
	
	  add: {-1. 1. -1};
	  add: {-1. 1. 1};
	  add: {1. 1. 1};
	  add: {1. 1. -1};
	
	  add: {-1. -1. -1};
	  add: {1. -1. -1};
	  add: {1. -1. 1};
	  add: {-1. -1. 1};
	
	  add: {1. -1. -1};
	  add: {1. 1. -1};
	  add: {1. 1. 1};
	  add: {1. -1. 1};
	
	  add: {-1. -1. -1};
	  add: {-1. -1. 1};
	  add: {-1. 1. 1};
	  add: {-1. 1. -1};
	yourself! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/25/2012 15:30'!
default: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.
	xtran := 0.
	ytran := 30.
	ztran := -384.
	self on: #keyStroke send: #captureKey: to: self.
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 17:24'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/25/2012 12:53'!
districtColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 14:38'!
drawBuilding: aDistrict x: x z: z dxSize: dxSize

	| bxSize bzSize bColor|
	bColor := Color new. 
	bxSize := x +1 .
	bzSize := z +1.
	aDistrict buildings do: [:building |
		(building heightSelector asInteger> configuration buildingMediumHeightColor)
		ifTrue: [
			bColor := configuration buildingMediumColor.
			]
		ifFalse: [
			bColor := configuration buildingLowColor.
			].
		(building heightSelector asInteger> configuration buildingMaxHeightColor)
		ifTrue: [
			bColor := configuration buildingHighColor.
			].
		(dxSize < (bxSize+ building widthSelector asInteger +1))
		"problem with gap siwe = 1"
		ifTrue: [
			bzSize := bzSize + configuration buildingGap.
			bxSize := x + 1.
			self buildingColor: { x+1 . (building heightSelector asInteger) . bzSize } color: bColor.
			"self building: { x+1 . (building heightSelector asInteger) . bzSize }."
			bxSize := bxSize + (configuration buildingGap).
			]
		ifFalse: [
			self buildingColor: { bxSize . (building heightSelector asInteger) . bzSize } color: bColor.
			"self building: { bxSize . (building heightSelector asInteger) . bzSize }."
			bxSize := bxSize + configuration buildingGap.
			].
	].! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/25/2012 16:22'!
drawCity: anImporter
	|sizeArray|
	sizeArray := self drawDistrict: anImporter city gap: configuration districtGap.
	"self city: {-1 . -0.1 . -1} to: sizeArray.
	"self cityColor: {-1 . -0.1 . -1} to: sizeArray color: configuration cityColor.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 14:43'!
drawDistrict:aCity gap: gap
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize |
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
	aCity districts do:[:district |
		dxSize := x + (district widthSelector asInteger*(configuration buildingGap ))+1.
		dzSize := z + (district widthSelector asInteger*configuration buildingGap)+1.
		self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: configuration districtColor.
		"self district: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} ."
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		self drawBuilding: district x: x z: z dxSize: dxSize.
		x := dxSize + gap.
		
		
		( x > aCity widthSelector"(aCityImporter city widthSelector asInteger/2)")
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x+(dxSize - x).
			].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x.
			].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/24/2012 16:25'!
initialize
	| fontPath |
	
	super initialize.
	self on: #keyStroke send: #captureKey: to: self.
			
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
initializeForNewSession
	super initializeForNewSession.
	self loadTexture.
	self loadText.
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 11:03'!
loadTexture
	
	| buffer fileForm gl fileFormGrass fileFormFace fileFormTop fileFormDown buffer2 buffer3 fileFormDistrict fileFormCity |
	fileFormGrass := (PNGReadWriter formFromFileNamed: 'grass.png').
	fileFormFace := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormTop := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDown := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDistrict := (PNGReadWriter formFromFileNamed: 'district.png').
	fileFormCity := (PNGReadWriter formFromFileNamed: 'city.png').
	
	gl := display gl.
	buffer := ByteArray new: 24.	
	gl genTextures_n: 6 textures: buffer.
	 
	face := buffer nbUlongAt: 1. 
	top := buffer nbUlongAt: 5.
	down := buffer nbUlongAt: 9.
	grass := buffer nbUlongAt: 13.
	city := buffer nbUlongAt: 17.
	district := buffer nbUlongAt: 21.
	
	gl bindTexture_target:  GL_TEXTURE_2D texture: face.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormFace width) height: (fileFormFace height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormFace bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	
	gl bindTexture_target:  GL_TEXTURE_2D texture: top.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormTop width) height: (fileFormTop height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormTop bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: down.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDown width) height: (fileFormDown height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDown bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: grass.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormGrass width) height: (fileFormGrass height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormGrass bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: city.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormCity width) height: (fileFormCity height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormCity bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR."
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_S param: GL_REPEAT;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_T param: GL_REPEAT."

	gl bindTexture_target:  GL_TEXTURE_2D texture: district.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDistrict width) height: (fileFormDistrict height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDistrict bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	self assert: (gl getError = GL_NO_ERROR)! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/17/2012 14:40'!
openInWorld
	| window |

	window := super openInWorld.
	
	self startStepping.
	self takeKeyboardFocus! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/7/2012 16:42'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 4/25/2012 16:34'!
render

	| gl cimport ring diffuse specular shinines l_pos t |
	self checkSession.
	
	gl := display gl.
	gl 		
		enable: GL_MULTISAMPLE ;		
		shadeModel: GL_SMOOTH;		
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.			
	gl 
		clearColor_red: configuration glBackground red green:  configuration glBackground green blue:  configuration glBackground blue alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.
	gl 
		matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	
	"
  	diffuse := GLFloatRGBA new.
	diffuse r: 1; g: 1;b: 1; a:1. 	
	specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 		
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: xrot ; y: yrot;z: zrot. 	
		
	gl 
		materialfv_face: GL_FRONT pname: GL_DIFFUSE params: diffuse;
		materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS params: shinines;
		lightfv_light: GL_LIGHT0  pname: GL_POSITION  params: l_pos;
		lightfv_light: GL_LIGHT0  pname: GL_DIFFUSE  params: diffuse;
		
		enable: GL_LIGHTING;
		enable: GL_LIGHT0.
		"
	self applyCamera.
	
	self drawCity: model.
	"Transcript
		clear;
		show: 'diffuse:', diffuse r asString, ' ',diffuse g asString, ' ',diffuse b asString;
		cr;
		show: 'specular:', specular r asString, ' ',specular g asString, ' ',specular b asString;
		cr;
		show: 'shinines:', shinines r asString;
		cr;
		show: 'l_pos:', l_pos x asString, ' ',l_pos y asString, ' ', l_pos z asString."
		
	gl flush.! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 16:23'!
rotateDown

	configuration cameraXPos: (configuration cameraXPos+ 1).
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 16:23'!
rotateLeft

	configuration cameraYPos: (configuration cameraYPos+ 1).
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0."! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 16:23'!
rotateRight
	
	configuration cameraYPos: (configuration cameraYPos - 1).
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0. "! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 16:23'!
rotateTop
	configuration cameraXPos: (configuration cameraXPos - 1).
	"display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
step
	self changed! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 4/23/2012 10:46'!
stepTime
	^5! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateBackward

	ztran := ztran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateDown

	ytran := ytran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/17/2012 17:30'!
translateForward

	ztran := ztran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateLeft

	xtran := xtran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateRight

	xtran := xtran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateTop

	ytran := ytran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/7/2012 16:42'!
vertex: array texCoord: t

	display gl 
		texCoord2d_s:  t first t:  t second;
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLTest
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
building_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
city_x: x y: y z: z
	|gl|
	
	gl := display gl.

	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: grass. 	
		
	gl begin: GL_QUADS;
		
		color3f_red: 1 green: 1 blue: 1; 
		vertex3f_x: -1 y: y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 1 t: 0; 
		
		vertex3f_x: -1 y:  y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y  z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 1 t: 0; 

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: 0.5 green: 0.5 blue: 0.5; 

		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third; 
		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayEnd third; 
		
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayStart third; 
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayStart third; 

	end.	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:09'!
initialize
	
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	
	
	rot := 0.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 11:46'!
render
	|gl curveRenderer x tab y z  cimport diffuse specular shinines l_pos |
	
	gl := display gl.
	display clear: Color black.
	
	
  	diffuse := GLFloatRGBA new.
	diffuse r: 1; g: 1;b: 1; a:1. 	
	specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 		
	shinines:= GLFloatRGBA new.
	shinines r: 0.1. 	
	l_pos := GLFloatVector new.
	l_pos x: 0; y: 0;z: 0. 	
	
	gl
		enable: GL_CULL_FACE;
		enable: GL_MULTISAMPLE;
		enable: GL_MULTISAMPLE_ARB;
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		enable: GL_LINE_SMOOTH;
	
	
		materialfv_face: GL_FRONT pname: GL_DIFFUSE params: diffuse;
		materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS params: shinines;
		lightfv_light: GL_LIGHT0  pname: GL_POSITION  params: l_pos;
		lightfv_light: GL_LIGHT0  pname: GL_DIFFUSE  params: diffuse;
		
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;

		
		"polygonMode_face: GL_FRONT mode: GL_LINE;"

		matrixMode: GL_PROJECTION;
		loadIdentity;
		frustum_left: (self width/2) negated 
		right: (self width/2) 
		bottom: (self width/2) negated
		top: (self width/2)
		zNear: 0
		zFar: self width .			
	gl
		matrixMode: GL_MODELVIEW;
		loadIdentity;
		scalef_x: 1/5.0 y: 1/5.0  z: 1/5.0 .
	gl rotatef_angle: (rot\\360) x: 1 y: 1 z: 1.
	gl scalef_x:  1 y: 1  z: 1.
	
	self line_x: -0.2 y: -0.2 z: -0.2.
	x := 0.
	y := 1.
	z := 0.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
step
	rot := rot + 2.
	self changed! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
stepTime
	^ 5! !

Object subclass: #CityConfiguration
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMediumHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground openGL model buildingMediumColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityConfiguration commentStamp: '<historical>' prior: 0!
This class is the class who configure the visualisation of the SourceCity. 

In this class you can choice color, maxheight ... for city, building ....!

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingGap
	^ buildingGap! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingGap: anObject
	buildingGap := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingHighColor
	^ buildingHighColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingHighColor: anObject
	buildingHighColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingLowColor
	^ buildingLowColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingLowColor: anObject
	buildingLowColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxHeightColor
	^ buildingMaxHeightColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxHeightColor: anObject
	buildingMaxHeightColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxWidthColor
	^ buildingMaxWidthColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxWidthColor: anObject
	buildingMaxWidthColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:47'!
buildingMediumColor
	^ buildingMediumColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:47'!
buildingMediumColor: anObject
	buildingMediumColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:22'!
buildingMediumHeightColor
	^ buildingMediumHeightColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:22'!
buildingMediumHeightColor: anObject
	buildingMediumHeightColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraXPos
	^ cameraXPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraXPos: anObject
	cameraXPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraYPos
	^ cameraYPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraYPos: anObject
	cameraYPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraZPos
	^ cameraZPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraZPos: anObject
	cameraZPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cityColor
	^ cityColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cityColor: anObject
	cityColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtColor
	^ districtColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtColor: anObject
	districtColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtGap
	^ districtGap! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtGap: anObject
	districtGap := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
glBackground
	^ glBackground! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
glBackground: anObject
	glBackground := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 16:33'!
model
	^ model! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 16:33'!
model: anObject
	model := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
openGL
	^ openGL! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
openGL: anObject
	openGL := anObject! !

Object subclass: #CityImporter
	instanceVariableNames: 'classes methods packages city districts buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/25/2012 13:31'!
basicBuilding: aClassName district: aDistrict
	| b |
	b := Building new model:  aClassName;hisDistrict: aDistrict.
	
	"(b heightSelector > configuration buildingMaxHeight contents)
	ifTrue: [
		(((aClassName selectors) size) > 20)
		ifTrue: [
			b colorSelector: { (((aClassName selectors) size) /10) . 0 . 0 }
		]
		ifFalse: [
			b colorSelector: { 0. (((aClassName selectors) size) /20)  . 0 }
		].	
	]
	ifFalse: [
		b colorSelector: {  0 . 0 . 1}.	
	]."
	aDistrict add: b.
	^b.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/25/2012 13:45'!
basicDistrict: aPackageName city: aCity
	 | d |
	d := District new model: (self packageNamed: aPackageName);hisCity: aCity.
	city add: d.
	^d
	
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:33'!
city
	^city! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/25/2012 13:10'!
cityNamed: aName withPackageNames: aCol

	city := City new model: aName; name: aName.
	aCol do: [:each |
				self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:23'!
districts
	^ city districts.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:58'!
ensureBuilding: aClassName district: aDistrict

	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:48'!
ensureDistrict: aPackageName

	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/19/2012 15:37'!
importClassAsBuilding
	(self city districts) do:[
		:each|
		(each model classes) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [ self importClassAsBuilding: eachClass district: each ]]
			displayingProgress: 'importing classes'
		].! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:56'!
importClassAsBuilding: aClassName district: aDistrict

	| ctPack |
	ctPack := self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 15:43'!
importPackageAsDistrict: aPackageName

	| ctPack |
	ctPack := self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/3/2012 14:08'!
initialize

	super initialize.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:56'!
numberOfBuilding
	|number|
	number:= 0.
	city districts do:[:each |
		number := number + each buildings size.].
	^number! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:54'!
numberOfDistrict
	^city districts size! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/2/2012 14:28'!
packageNamed: aString

	^ RPackageOrganizer default packageNamed: aString! !

Object subclass: #CityObject
	instanceVariableNames: 'model widthSelector heightSelector colorSelector historyArray historyChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityObject commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

CityObject subclass: #Building
	instanceVariableNames: 'hisDistrict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 13:41'!
heightSelector
	^((1 + model selectors size) ln asInteger) * 2! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:33'!
hisDistrict
	^hisDistrict ! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:04'!
hisDistrict: aDistrict
	hisDistrict := aDistrict.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:40'!
printOn: aStream

	hisDistrict ifNotNil: [ aStream
					nextPutAll: hisDistrict asString; 
					nextPutAll: ' -> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling Name : '; 
					nextPutAll: model name].! !

CityObject subclass: #City
	instanceVariableNames: 'districts name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City methodsFor: 'adding' stamp: 'DouailleErwan 4/18/2012 10:02'!
add: aDistrict

	districts add: aDistrict.
	self widthSelector: (districts size).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:36'!
districts

	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:51'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'testing' stamp: 'DouailleErwan 4/2/2012 14:48'!
hasDistrictNamed: aString
	
	^ districts anySatisfy: [:each | each model name = aString]! !

!City methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize

	super initialize.
	"districts := Dictionary new."
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name
	^ name! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name: anObject
	name := anObject! !

!City methodsFor: 'accessing' stamp: 'douaille 4/10/2012 09:37'!
printOn: aStream

	model ifNotNil: [ aStream 
					nextPutAll: ' City name : '; 
					nextPutAll: self name].! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 14:45'!
widthSelector
	^super widthSelector/2 asFloat roundedUp! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector
	^colorSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector: anObject
	colorSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
heightSelector
	^heightSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
heightSelector: anObject
	heightSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray
	^ historyArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray: anArray
	 historyArray := anArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice
	 ^historyChoice! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice: selectedHistory
	 historyChoice := selectedHistory! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize
	
	self widthSelector: #0.
	self colorSelector: #0.
	self heightSelector: #0.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector
	^widthSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector: anObject
	widthSelector := anObject.! !

CityObject subclass: #District
	instanceVariableNames: 'hisCity buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District methodsFor: 'printing' stamp: 'DouailleErwan 4/18/2012 10:02'!
add: aBuilding

	buildings add: aBuilding.
	self widthSelector: (buildings size).
	^ aBuilding.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/3/2012 14:15'!
buildings
	^buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity
	^hisCity.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity: aCity
	hisCity := aCity.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize 
	

	super initialize.
	"buildings := Dictionary new."
	buildings := OrderedCollection new.! !

!District methodsFor: 'printing' stamp: 'douaille 4/11/2012 14:56'!
printOn: aStream

	hisCity ifNotNil: [ aStream
					nextPutAll: hisCity asString;
					nextPutAll: '-> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' District Name : '; 
					nextPutAll: model name;
					nextPutAll: self buildings size ].! !

!District methodsFor: 'accessing' stamp: 'douaille 4/11/2012 17:52'!
widthSelector
	^super widthSelector sqrt asFloat roundedUp! !

Object subclass: #CityVisualization
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground listPackages openGL win model buildingMediumHeightColor buildingMediumColor glCity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityVisualization commentStamp: '<historical>' prior: 0!
A CityVisualization is the class who you use to configure the parameters of your draw 3D visualization, pakcage which you enter.!

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingGap
	
	^ buildingGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingGap: anObject
	
	buildingGap := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor
	
	^ buildingHighColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor: anObject
	
	buildingHighColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor
	
	^ buildingLowColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor: anObject
	
	buildingLowColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxHeightColor
	
	^ buildingMaxHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxHeightColor: anObject
	
	buildingMaxHeightColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxWidthColor
	
	^ buildingMaxWidthColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxWidthColor: anObject
	
	buildingMaxWidthColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:41'!
buildingMediumColor
	
	^ buildingMediumColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:41'!
buildingMediumColor: anObject
	
	buildingMediumColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:40'!
buildingMediumHeightColor
	
	^ buildingMediumHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:40'!
buildingMediumHeightColor: anObject
	
	buildingMediumHeightColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos
	
	^ cameraXPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos: anObject
	
	cameraXPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos
	
	^ cameraYPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos: anObject
	
	cameraYPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos
	
	^ cameraZPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos: anObject
	
	cameraZPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor
	
	^ cityColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor: anObject
	
	cityColor := anObject! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 10:46'!
cityConfigurationBuild
	|config|
	config := CityConfiguration new.
	^config cityColor: self cityColor selectedColor;
		districtColor: self districtColor selectedColor;
		districtGap: self districtGap contents asInteger;
		buildingLowColor: self buildingLowColor selectedColor;
		buildingMediumColor: self buildingMediumColor selectedColor;	
		buildingHighColor: self buildingHighColor selectedColor;	
		buildingGap: self buildingGap contents asInteger;
		buildingMediumHeightColor: self buildingMediumHeightColor contents asInteger;
		buildingMaxHeightColor: self buildingMaxHeightColor contents asInteger;
		buildingMaxWidthColor: self buildingMaxWidthColor contents asInteger;
		glBackground: self glBackground selectedColor ;
		cameraXPos: self cameraXPos contents asInteger;
		cameraYPos: self cameraYPos contents asInteger;
		cameraZPos: self cameraZPos contents asInteger;
		model: self model.! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:33'!
components
	^(win newTabGroup: {
			(win newRow: {
				win newImage: PharoTheme newDefault smallConfigurationIcon . 
				win newLabel: 'Importer configuration'	})->
				(win newGroupbox: 'Select packages to visualize' forAll: {
					(listPackages)hResizing: #spaceFill;vResizing: #spaceFill.}).
				'City settings'->(
						(win newTitle: 'District color' for: (
							(cityColor) minHeight: 80; minWidth: 120;vResizing: #spaceFill))).
				'Districts settings'->(
					win newRow:{
						win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'District color' for: (
							(districtColor) minHeight: 80; minWidth: 120)).
						}.
						win newGroupbox: 'Size settings' forAll:{
						(win newTitle: 'Gap between each district' for: (
							(win newTextEntryFor:  (districtGap)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}}).
				'Buildings settings'->(
					win newRow:{
						win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'Low color' for: ((
							(buildingLowColor) minHeight: 80; minWidth: 120))).
						(win newTitle: 'Medium color' for: ((
							(buildingMediumColor) minHeight: 80; minWidth: 120))).
						(win newTitle: 'High color' for: (
							(buildingHighColor) minHeight: 80; minWidth: 120))
						}.
						win newGroupbox: 'Size settings' forAll:{
						(win newTitle: 'Gap between each building' for: (
							(win newTextEntryFor:  (buildingGap)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
						(win newTitle: 'Medium height building' for: (
							(win newTextEntryFor:  (buildingMediumHeightColor)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
						(win newTitle: 'Max height building' for: (
							(win newTextEntryFor:  (buildingMaxHeightColor)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
						(win newTitle: 'Max width building' for: (
							(win newTextEntryFor:  (buildingMaxWidthColor)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}}).
				'OpenGL view settings'->(
					win newRow:{
						win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'Background color' for: (
							(glBackground) minHeight: 80; minWidth: 120)).
						}.
						win newGroupbox: 'Camera default position settings' forAll:{
						(win newTitle: 'x' for: (
							(win newTextEntryFor:  (cameraXPos)
								getText: #contents
								setText:  #contents:
								help: 'insert an Integer'))).
						(win newTitle: 'y' for: (
							(win newTextEntryFor:  (cameraYPos)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
						(win newTitle: 'z' for: (
							(win newTextEntryFor:  (cameraZPos)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}}).
				}).! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:09'!
display
	|dock container |
		dock := win newToolDockingBar.
		dock
			addMorph: self toolbar.
			
		container := PanelMorph new.
		container 
			changeTableLayout; 
			listDirection: #rigthToLeft.
		container addMorph: self components.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity Configuration';
			openInWorld;
			width: 700;
			height: 500.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor
	
	^ districtColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor: anObject
	
	districtColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap
	
	^ districtGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap: anObject
	
	districtGap := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground
	
	^ glBackground! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground: anObject
	
	glBackground := anObject! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/24/2012 11:33'!
helpDisplay
	|dialog builder window|
	window := UITheme .
	builder := window exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Help !!') useDefaultOKButton.
	dialog contentMorph: (
		(dialog newRow: {
				(dialog newTextEditorFor: (ValueHolder new contents: 'SourceCity Information',Character cr asString,'Shortcut keyboard :') 
				getText: #contents 
				setText: #contents:) minWidth: 300;minHeight: 600;disable .
			})vResizing: #spaceFill); model: nil.
	builder openModal: dialog! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 14:58'!
initialize
	win := StandardWindow new.
	listPackages := PluggableListMorph on: (ListModel new list: RPackageOrganizer default packageNames) 
		list: #list
		primarySelection: #selectionIndex 
		changePrimarySelection: #selectionIndex:
		listSelection: nil
		changeListSelection: nil
		menu: nil.
	cityColor := win newHSVSelector: (Color r: 0.6 g: 0.6 b: 0.6) 
		help: 'This is a hue-saturation-volume selector'.
	districtColor := win newHSVSelector: (Color r: 0.8 g: 0.8 b: 0.8)
		help: 'This is a hue-saturation-volume selector'.
	districtGap := ValueHolder new contents: '2'.
	buildingLowColor := win newHSVSelector: (Color r: 0 g: 0 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	buildingMediumColor := win newHSVSelector: (Color  r: 0 g: 1 b: 0)
		help: 'This is a hue-saturation-volume selector'.
	buildingHighColor := win newHSVSelector: (Color  r: 1 g: 0 b: 0)
		help: 'This is a hue-saturation-volume selector'.
	buildingGap := ValueHolder new contents: '2'.
	buildingMediumHeightColor := ValueHolder new contents: '5'.
	buildingMaxHeightColor := ValueHolder new contents: '10'.
	buildingMaxWidthColor := ValueHolder new contents: '5'.
	glBackground := win newHSVSelector: (Color r: 1 g: 1 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	cameraXPos := ValueHolder new contents: '-196'.
	cameraYPos := ValueHolder new contents: '-15'.
	cameraZPos := ValueHolder new contents: '0'.
	model := CityImporter new.
	"model cityNamed: 'CodCT' withPackageNames: #('AST-Core' 'SourceCity' 'Morphic' 'CollectionsTests-Abstract' 'Polymorph-Widgets')."
	model cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	self display! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages
	
	^ listPackages! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages: anObject
	
	listPackages := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model
	^ model! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model: anObject
	model := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:50'!
openGL
	
	^ openGL! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
openGL: anObject
	
	openGL := anObject! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:04'!
refreshActivity
	(glCity isNil)
	ifFalse: [
		glCity changeConfiguration: self cityConfigurationBuild.
		].
	! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:01'!
startActivity
	glCity := GLCity new default: self cityConfigurationBuild;openInWorld.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:08'!
test
	^'youhou'! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:07'!
test: anObject
	Transcript cr;show:anObject.! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:23'!
toolbar
	^win newToolbar: {
		win newButtonFor: self 
			getState:  nil
			action:  #startActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallDoItIcon 
			help:'Start City view' .
		win newButtonFor: self 
			getState:  nil
			action:  #refreshActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallUpdateIcon 
			help:'Change current configuration' .
			}.! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/26/2012 11:07'!
update: aSymbol 
	self refreshActivity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
win
	
	^ win! !
